﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=12.8
@EndOfDesignText@

'Code module
'Subs in this code module will be accessible from all modules.

Sub Process_Globals
	#If B4J
	Private fx As JFX
	#End If
	Private xui As XUI
	
	Public dd As DDD 'from DesignerUtils library, code generated
	Public ox, oy, dx, dy As Double 'How to Move the Form

	Type PageSettings (Left As Int, Top As Int, Width As Int, Height As Int, _
		IsIconified As Boolean, Theme As String, Style As String, PnlBGColor As Int)
	Private ps As PageSettings
	Private kvs As KeyValueStore
	Public recentPageID As String
	Public panelBGColor As Int
	Public cvsDrawEdit As B4XCanvas 'code generated
	
	Private menucolor = 0xFF333366 As Int
	Private firstbgcolor = 0x000 As Int
	Private bgcolor = 0xFF2C254A As Int
	Private bgitem2 = 0xFF656599 As Int
	Private bgitem1 = 0xFF323266 As Int
	Private textcolor = 0xFFD3D3D3 As Int

End Sub

Sub SavePageSettings (PageID As String)
	Dim Page As Object = B4XPages.GetPage(PageID)
	Try
		UpdateFormSettings (B4XPages.GetNativeParent(Page))
		kvs.Put("Page", FormToPS(B4XPages.GetNativeParent(Page)))
		Log("Done SavePageSettings, Key String: " & B4XPages.GetPageId(Page) & " - " & FormToPS(B4XPages.GetNativeParent(Page)))
	Catch
		Log("Error in SavePageSettings, Key String: " & B4XPages.GetPageId(Page) & " - " & FormToPS(B4XPages.GetNativeParent(Page))  &" - " & LastException)
	End Try
End Sub

Sub SavePageBG
	Try
		If Not(cvsDrawEdit.CreateBitmap = Null) Then
			cvsDrawEdit.Invalidate
			kvs.PutBitmap("Canvas", cvsDrawEdit.CreateBitmap)
		End If
	Catch
		Log("Error in SavePageBG: " & LastException)
	End Try
End Sub

'Retain form  previous session location, size, theme and style

Sub LoadPageSettings (PageID As String, calledFrom As String)
	If Not(ps.IsInitialized) Then
		ps.Initialize
	End If
	
	If recentPageID = "MainPage" Then
		Select PageID
			Case "MainPage"
				LoadInitialPageSettings("MainPage", calledFrom)
			Case "AppDashUI 1"
				LoadPageSettingsFrmRecentPage("AppDashUI 1", calledFrom)
		End Select
	Else If recentPageID = "AppDashUI 1" Then
		Select PageID
			Case "MainPage"
				LoadPageSettingsFrmRecentPage("MainPage", calledFrom)
			Case "AppDashUI 2"
				LoadPageSettingsFrmRecentPage("AppDashUI 2", calledFrom)
		End Select
	Else If recentPageID = "AppDashUI 2" Then
		LoadPageSettingsFrmRecentPage("AppDashUI 1", calledFrom)
	End If
End Sub

Private Sub LoadInitialPageSettings (PageID As String, calledFrom As String)
	Dim Page As Object
	'PageSettings (Left As Int, Top As Int, Width As Int, Height As Int, IsIconified As Boolean, Theme As String, Style As String)
	Page = B4XPages.GetPage("MainPage")
	Try
		#If B4J
		xui.SetDataFolder("appdashuidata")
		kvs.Initialize(xui.DefaultFolder, "kvs.dat")
		#Else If B4A Or B4i
		#End if
		ps = kvs.Get("Page")
		If ps = Null Then Return
		SetFormFromMap(ps, B4XPages.GetNativeParent(Page))
		Log("Done LoadMainPageSettings, " & "called from: " & calledFrom & ", " & _
			"recentPageID/PageID: " & recentPageID & " / " & B4XPages.GetPageID(Page) & _
			" /  PageSettings: " & ps & " / " & xui.DefaultFolder)
		Log(" ")
	Catch
		Log("Error in LoadMainPageSettings: " & "called from: " & calledFrom & ", " & _
			PageID & " / " & recentPageID & "  / " & B4XPages.GetPageID(Page) & _
			" /  PageSettings: " & ps & " / " & xui.DefaultFolder & " / " & LastException)
		Log(" ")
	End Try

End Sub

Private Sub LoadPageSettingsFrmRecentPage (PageID As String, calledFrom As String)
	Try
		Dim Page As Object
		Page = B4XPages.GetPage(recentPageID)
		ps.Left = B4XPages.GetNativeParent(Page).WindowLeft
		ps.Top = B4XPages.GetNativeParent(Page).WindowTop
		ps.Width = B4XPages.GetNativeParent(Page).WindowWidth
		ps.Height = B4XPages.GetNativeParent(Page).WindowHeight
		ps.IsIconified = False
		ps.PnlBGColor = panelBGColor
		Page = B4XPages.GetPage(PageID)
		B4XPages.GetNativeParent(Page).WindowLeft = ps.Left
		B4XPages.GetNativeParent(Page).WindowTop = ps.Top
		B4XPages.GetNativeParent(Page).WindowWidth = ps.Width
		B4XPages.GetNativeParent(Page).WindowHeight = ps.Height
		Log("Done LoadPageSettingsFrmRecentPage: " & "called from: " & calledFrom & _
			", " & recentPageID & " at " & ps.Left & ", " & ps.Top & ", " & ps.Width & _
			", " & ps.Height)
		Log("Envoked Page/Previous Page: " & PageID & " / " & recentPageID)
		Log(" ")
	Catch
		Log("Error in LoadPageSettingsFrmRecentPage: " & "called from: " & calledFrom & _
			", " &LastException)
		Log("Envoked Page/Previous Page: " & PageID & " / " & recentPageID)
		Log(" ")
	End Try

End Sub

Sub FormToPS (frm As Form) As PageSettings
	Return DoPageSettings(frm.WindowLeft, frm.WindowTop, frm.WindowWidth, frm.WindowHeight, _
		frm.As(JavaObject).GetFieldJO("stage").RunMethod("isIconified", Null), UIThemes.frmTheme, _
		UIThemes.frmStyle, panelBGColor)
End Sub

Private Sub SetFormFromMap(pgP As PageSettings, frm As Form)
	Try
		frm.WindowLeft = pgP.Left
		frm.WindowTop = pgP.Top
		frm.WindowWidth = pgP.Width
		frm.WindowHeight = pgP.Height
		UIThemes.frmTheme = pgP.Theme
		UIThemes.frmStyle = pgP.Style
		panelBGColor = pgP.PnlBGColor
	Catch
		Log(LastException)
	End Try
	Dim iconified As Boolean = pgP.IsIconified
	If iconified Then
		Dim jo As JavaObject = frm
		jo.GetFieldJO("stage").RunMethod("setIconified", Array(iconified))
	End If
	'check that left and top are in screen boundaries
	Dim goodLeft, goodTop As Boolean
	Dim fx As JFX
	For Each screen As Screen In fx.Screens
		If frm.WindowLeft >= screen.MinX And frm.WindowLeft <= screen.MaxX Then
			goodLeft = True
		End If
		If frm.WindowTop >= screen.MinY And frm.WindowTop <= screen.MaxY Then
			goodTop = True
		End If
	Next
	If Not(goodLeft) Then frm.WindowLeft = 0
	If Not(goodTop) Then frm.WindowTop = 0
End Sub

Private Sub DoPageSettings (Left As Int, Top As Int, Width As Int, Height As Int, _
		IsIconified As Boolean, pgTheme As String, pgStyle As String, _
		pnlBGColor As Int) As PageSettings
	Dim ps As PageSettings
	Try
		If Not(ps.IsInitialized) Then
			ps.Initialize
		End If
		ps.Left = Left
		ps.Top = Top
		ps.Width = Width
		ps.Height = Height
		ps.IsIconified = IsIconified
		ps.Theme = pgTheme
		ps.Style = pgStyle
		ps.PnlBGColor = pnlBGColor
	Catch
		Log(LastException)
	End Try
	Return ps
End Sub


Sub SetAppPanelColor (thisPanel As B4XView, width As Int, height As Int)
	Try	
		If B4XPages.GetPageId(thisPanel) = "AppDashUI 1" Then
			thisPanel.Color = panelBGColor
		Else If B4XPages.GetPageId(thisPanel) = "AppDashUI 2" Then 'pnlDrawingCanvas
			thisPanel.Parent.Width = width
			thisPanel.Parent.Height = height
			thisPanel.Parent.Color = panelBGColor
			thisPanel.Parent.SetColorAndBorder(panelBGColor, 0, panelBGColor, 0)
		End If
		Log("Panel Size: " & thisPanel.Parent.Width & "/" & thisPanel.Parent.Height & _
			" Panel Color: " & thisPanel.Parent.Color)
	Catch
		Log("Error in SetAppPanelColor/Panel Size: " & thisPanel.Parent.Width & "/" & _
			thisPanel.Parent.Height & " Panel Color: " & thisPanel.Parent.Color& LastException)
		Log(" ")
	End Try
End Sub

Sub UpdateCanvasPnlBGcolor (cvs As B4XCanvas)
	cvs.DrawRect(cvs.TargetRect, panelBGColor, True, 0)
End Sub

Sub UpdateImgVwFrmSavedBitmap (imgVw As B4XView)
	Try
		imgVw.Parent.Color = panelBGColor
		imgVw.SetBitmap(kvs.GetBitmap("Canvas"))
	Catch
		Log("Error in UpdateImgVwFrmSavedBitmap: " & imgVw.Tag.As(String) & " - " & LastException)
	End Try
End Sub

Sub InitializeCvsDrawEdit (Pane As B4XView)
	Try
		If Pane.IsInitialized Then
			cvsDrawEdit.Initialize(Pane)
			cvsDrawEdit.DrawRect(cvsDrawEdit.TargetRect, panelBGColor, True, 0)
			cvsDrawEdit.DrawBitmap(kvs.GetBitmap("Canvas"), cvsDrawEdit.TargetRect)
		End If
	Catch
		Log("Error in InitializeCvsDrawEdit: " & Pane.Tag.As(String) & ", " & LastException)
	End Try
End Sub

Sub SaveAppPageSettings (PageID As String)
	#If B4J
	recentPageID = PageID
	SavePageSettings(recentPageID)
	#End If
End Sub

Sub ShowOtherPage (recentPage As String, nextPage As String)
	#If B4J
	UpdateFormSettings (B4XPages.GetNativeParent(B4XPages.GetPage(recentPage)))
	recentPageID = recentPage
	B4XPages.ShowPageAndRemovePreviousPages(nextPage)
	#End If
End Sub

Sub InitializeFormUtils (page As Object)
	FormUtils.SetMinWidth(B4XPages.GetNativeParent(page),400)
	FormUtils.SetMinHeight(B4XPages.GetNativeParent(page),400)
'	FormUtils.SetFullScreenExitHint(B4XPages.GetNativeParent(page),"Press Ctrl+I")
'	FormUtils.SetFullScreenExitKeyCombination(B4XPages.GetNativeParent(page),FUtils_KeyCombinations.GetKeyCombination(Array As String(FUtils_KeyCombinations.KC_CONTROL,"I")))
'	FormUtils.SetFullScreen(B4XPages.GetNativeParent(page),True)
	Dim Img As Image = fx.LoadImage(File.DirAssets,"icon.png")
	FormUtils.GetIcons(B4XPages.GetNativeParent(page)).Add(Img)
End Sub

Sub MouseDragged (Page As Object, pgEventData As MouseEvent)
	'Handle draggable form area
	Dim jo As JavaObject = pgEventData
	If B4XPages.GetNativeParent(Page).Showing Then
		B4XPages.GetNativeParent(Page).WindowLeft = jo.RunMethod("getScreenX", Null) - ox + _
			(B4XPages.GetNativeParent(Page).Width - B4XPages.GetNativeParent(Page).WindowWidth) / 2
		B4XPages.GetNativeParent(Page).WindowTop = jo.RunMethod("getScreenY", Null) - oy + _
			(B4XPages.GetNativeParent(Page).Height - B4XPages.GetNativeParent(Page).WindowHeight) / 1.2
	End If
End Sub

Sub MousePressed (Page As Object, pgEventData As MouseEvent)
	Dim newForm As Form = B4XPages.GetNativeParent(Page)
	If newForm.Showing Then
		ox = pgEventData.X
		oy = pgEventData.Y
	End If
	Dim jo As JavaObject = pgEventData
	Log("Clicked at ScreenX = " & jo.RunMethod("getScreenX", Null) & _
		" | ScreenY = " &  jo.RunMethod("getScreenY", Null))
	Log("Clicked at ox = " & ox & " | oy = " &  oy)
	Log("WindowLeft = " & newForm.WindowLeft & " | WindowTop = " &  newForm.WindowTop)
	Log("Form.Width = " & newForm.Width & " | Form.WindowWidth = " &  newForm.WindowWidth)
	Log("Form.Height = " & newForm.Height & " | Form.WindowHeight = " &  newForm.WindowHeight)
	Log("Form.Title = " & newForm.Title & " | RootPane.Style = " & newForm.RootPane.Style)
End Sub

Sub MouseReleased (Page As Object, pgEventData As MouseEvent)
	Dim newForm As Form = B4XPages.GetNativeParent(Page)
	If newForm.Showing Then
		ox = pgEventData.X
		oy = pgEventData.Y
	End If
	UpdateFormSettings (newForm)
	Dim jo As JavaObject = pgEventData
	Log("Mouse Released at ScreenX = " & jo.RunMethod("getScreenX", Null) & _
		" | ScreenY = " &  jo.RunMethod("getScreenY", Null))
	Log("Mouse Released at ox = " & ox & " | oy = " &  oy)
	Log("WindowLeft = " & newForm.WindowLeft & " | WindowTop = " &  newForm.WindowTop)
	Log("Form.Width = " & newForm.Width & " | Form.WindowWidth = " &  newForm.WindowWidth)
	Log("Form.Height = " & newForm.Height & " | Form.WindowHeight = " &  newForm.WindowHeight)
	Log("Form.Title = " & newForm.Title & " | RootPane.Style = " & newForm.RootPane.Style)
End Sub

Sub UpdateFormSettings (thisForm As Form)
	'resolves flickering transition of form in showing only one window
	Try
		ps.Left = thisForm.WindowLeft
		ps.Top = thisForm.WindowTop
		ps.Width = thisForm.WindowWidth
		ps.Height = thisForm.WindowHeight

		If Not(B4XPages.GetNativeParent(B4XPages.MainPage) = Null) Then
			B4XPages.GetNativeParent(B4XPages.MainPage).WindowLeft = ps.Left
			B4XPages.GetNativeParent(B4XPages.MainPage).WindowTop = ps.Top
			B4XPages.GetNativeParent(B4XPages.MainPage).WindowWidth = ps.Width
			B4XPages.GetNativeParent(B4XPages.MainPage).WindowHeight = ps.Height
		End If
		If Not(B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI1) = Null) Then
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI1).WindowLeft = ps.Left
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI1).WindowTop = ps.Top
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI1).WindowWidth = ps.Width
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI1).WindowHeight = ps.Height
		End If
		If Not(B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI2) = Null)  Then
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI2).WindowLeft = ps.Left
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI2).WindowTop = ps.Top
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI2).WindowWidth = ps.Width
			B4XPages.GetNativeParent(B4XPages.MainPage.AppDashUI2).WindowHeight = ps.Height
		End If
	Catch
		Log("Error in UpdateFormSettings: " & LastException)
	End Try
End Sub

Sub RestartApplication (FilePath As String, filename As String)
	Try
		Dim sf As Object = xui.Msgbox2Async( _
			"Changing window form style requires restart.Save your data before continuing.", _
			"AppDashUI - Change Style", "OK", "Cancel", "", Null)
		Wait For (sf) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			SaveAppPageSettings("AppDashUI 1")
			RestartApp(FilePath, filename)
			Wait For RestartApp_Complete
			ExitApplication
		End If
	Catch
		Log(LastException)
	End Try
End Sub

Sub RestartApp (FilePath As String, filename As String)
	fx.ShowExternalDocument(File.GetUri(FilePath, filename))
	Sleep(2500)
	CallSubDelayed(Me, "RestartApp_Complete")
End Sub

'#Region Crossplatform Click Handling - Normal and Extra (LongClick for B4A/B4i or RightClick for B4J)
''based on https://www.b4x.com/android/forum/threads/b4x-cross-platform-click-events-handler-code-block.149627/
''All Button views with "btnMainPage" as its event name will be handled by subs below - the target event is the ViewName_NormalClick and ViewName_ExtraClick  
''
'#If B4J
'Private Sub btnMainPage_MouseClicked (eV As MouseEvent)
'	Dim vdata As DDDViewData = B4XPages.MainPage.dd.GetViewData(Sender)		'really fast: tested 4 msec per 100000 calls on B4J
'	If eV.SecondaryButtonPressed Then CallSub(Me, vdata.name & "_ExtraClick") Else CallSub(Me, vdata.name & "_NormalClick")
'End Sub
'#Else If B4A Or B4i
'Private Sub MainPageBtn_Click
'	Dim vdata As DDDViewData = B4XPages.MainPage.dd.GetViewData(Sender)
'	CallSub(B4XPages.GetManager.MainPage, vdata.Name & "_NormalClick")
'End Sub
'Private Sub MainPageBtn_LongClick
'	Dim vdata As DDDViewData = B4XPages.MainPage.dd.GetViewData(Sender)
'	CallSub(B4XPages.GetManager.MainPage, vdata.Name & "_ExtraClick")
'End Sub
'#End If
'#End Region
'
'
'
''Sub loadItams
''
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(0)),"Utenti Totali",resultU),40dip,40dip,280dip,280dip)
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(1)),"Utenti Attivi",resultU-resultInactiveU-BannedU),330,40dip,280dip,280dip)   '280dip,230dip)
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(2)),"Utenti non attivi",resultInactiveU),620,40dip,280dip,280dip)   '280dip,230dip)
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(3)),"Utenti Bannati",BannedU),910dip,40dip,280dip,280dip)'280dip,230dip)
'''	
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(4)),"Registrati Oggi",regTodayU),40dip,280dip,280dip,280dip)   '280dip,230dip)
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(5)),"Attivi Oggi",activeTodayU),330dip,280dip,280dip,280dip)  '280dip,230dip)
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(4)),"Vecchie versioni",undatedversion),620dip,280dip,280dip,280dip)   '280dip,230dip)
''	classicMainPane.AddView(createDesign1(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(5)),"Ultima versione",lastversionapp),910dip,280dip,280dip,280dip)
''	'
'''	classicMainPane.AddView(createDesign2(20dip,xui.LoadBitmap(File.DirAssets,imgset.Get(6)),"Satoshi totali raccolti",totalsatoshiSum),40dip,550dip,item2Pane1.Width,500dip)
'''	classicMainPane.AddView(createDesign2(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(7)),"Click Totali",totalclickSum),40dip,610dip,item2Pane1.Width,500dip)
'''	classicMainPane.AddView(createDesign2(40dip,xui.LoadBitmap(File.DirAssets,imgset.Get(8)),"Video Guardati Totali",totalvideoViewSum),40dip,670dip,item2Pane1.Width,500dip)
''
''
''End Sub
'
'
''Sub createDesign1(Width As Int, image As B4XBitmap, Title As String, text1 As Int) As Pane
''	Dim p As B4XView = xui.CreatePanel("")
''	Dim height As Int = 70dip
''	p.SetLayoutAnimated(0, 0, 0, Width, height)
''	p.LoadLayout("lyt_Item")
'''	PaneItem.Color = mycode.bgitem1
''	ItemLabel1.TextColor = mycode.textcolor  'xui.Color_LightGray
''	
''	
''	ItemImageView1.SetImage(image)
''	ItemLabel1.Text = Title
''	ItemCounter1.Value = text1
''	
''	Return p
''
''	
''End Sub
''
''Sub createDesign2(Width As Int, image As B4XBitmap, Title As String, text1 As Int) As Pane
''
''	Dim p As B4XView = xui.CreatePanel("")
''	Dim height As Int = 10dip
''	p.SetLayoutAnimated(0, 0, 0, Width, height)
''	p.LoadLayout("lyt_item2")
'''	item2Pane1.Color = mycode.bgitem2
''	item2Label2.TextColor = mycode.textcolor  'xui.Color_LightGray
''	item2Label3.TextColor = mycode.textcolor
''	
''	Item2B4XImageView1.Bitmap  = image
''	item2Label2.Text = Title
''	item2Label3.Text = text1
''	
''	Return p
''	
''End Sub
'
''Sub loadDesign1
''	
''	Dim item As String = Array("","","","","","")
''	Dim img As String = Array("icon.ong")
''	
''
''End Sub